package _VisualDVM.Passes.All;
import Common.Utils.Utils_;
import Common.Utils.Vector_;
import Common.Visual.Controls.PassControl;
import _VisualDVM.Global;
import _VisualDVM.Passes.Sapfor.SapforAnalysis;
import _VisualDVM.ProjectData.SapforData.Regions.ParallelRegion;
import _VisualDVM.ProjectData.SapforData.Regions.RegionsJson;

import java.util.Comparator;
import java.util.Vector;
public class SPF_GetArrayDistributionOnlyAnalysis extends SapforAnalysis {
    @Override
    protected Vector<String> getForbiddenPhases() {
        return new Vector_<>("SPF_GetArrayDistributionOnlyRegions");
    }
    @Override
    public String phase() {
        return "CREATE_DISTR_DIRS";
    }
    @Override
    protected boolean isAtomic() {
        return false;
    }
    @Override
    protected void unpack(String packed) throws Exception {
        RegionsJson regionsJson = Utils_.gson.fromJson(packed, RegionsJson.class);
        for (ParallelRegion parallelRegion : regionsJson.allRegions) {
            parallelRegion.Init();
            target.parallelRegions.put(parallelRegion.regionId, parallelRegion);
        }
        //отсортировать по имени шаблоны
        target.templates.sort(Comparator.comparing(o -> o.name));
        target.GenRules();
    }
    @Override
    protected void performPreparation() throws Exception {
        super.performPreparation(); //удаление интеррупта.
        //как то вывести эти методы в проект. чтобы и при очистке юзать.
        //иначе анархия.
        target.parallelRegions.clear();
        target.templates.clear();
        target.parallelVariants.clear();
    }
    @Override
    protected void showPreparation() {
        Global.mainModule.getUI().getVersionsWindow().getVariantsWindow().ShowNoProjectDistribution();
        Global.mainModule.getUI().getVersionsWindow().getVariantsWindow().ShowNoVariantsFilter();
        Global.mainModule.getUI().getVersionsWindow().getVariantsWindow().ShowNoVariants();
        Global.mainModule.getUI().getMainWindow().getProjectWindow().getAnalysisWindow().ShowNoRegions();
        Global.mainModule.getUI().getMainWindow().getProjectWindow().getAnalysisWindow().ShowNoProjectMaxDim();
    }
    @Override
    protected void showDone() throws Exception {
        Global.mainModule.getUI().getVersionsWindow().getVariantsWindow().ShowProjectDistribution();
        Global.mainModule.getUI().getVersionsWindow().getVariantsWindow().ShowVariantsFilter();
        Global.mainModule.getUI().getVersionsWindow().getVariantsWindow().ShowTotalVariantsCount();
        Global.mainModule.getUI().getVersionsWindow().getVariantsWindow().ShowFilteredVariantsCount();
        Global.mainModule.getUI().getMainWindow().getProjectWindow().getAnalysisWindow().ShowRegions();
        Global.mainModule.getUI().getMainWindow().getProjectWindow().getAnalysisWindow().ShowProjectMaxDim();
        super.showDone();
    }
    @Override
    protected void FocusResult() {
        Global.mainModule.getUI().getMainWindow().FocusProject();
        Global.mainModule.getUI().getMainWindow().getProjectWindow().FocusAnalysis();
    }
    @Override
    public String getDescription() {
        return "Анализ кода";
    }
    public void RefreshControls() {
        for (PassControl control : controls)
            control.setText(getDescription());
    }
}